#!/bin/bash

function printNavigation
{
  echo "<div id=\"titel\">Fr&ouml;ling P2</div>"
  echo "<div id=\"Tag\"><a href=\"../24std.png\">Tag</a></div>"
  echo "<div id=\"Woche\"><a href=\"../week.png\">Woche</a></div>"
  echo "<div id=\"Monat\"><a href=\"../month.png\">Monat</a></div>"
  echo "<div id=\"Jahr\"><a href=\"../year.png\">Jahr</a></div>"
  echo "<div id=\"Temperaturen\"><a href=\"../temperatur.html\">Temperaturen</a></div>"
  echo "<div id=\"rawdata\"><a href=\"../actual_data.txt\">Rohdaten</a></div>"
}

function printStatus {
  echo "Content-type: text/html"
  echo ""
  echo "<html><head><title>Fr&ouml;ling P2 - $TITEL</title>"
  echo "<meta content=\"text/html; charset=UTF-8\" http-equiv=\"content-type\">"
  echo "<meta http-equiv=\"refresh\" content=\"60\">"
  echo "<style type=\"text/css\"> 
  body { margin:0; font-family: sans-serif;} 
  a:link { text-decoration:none; color: black }
  a:visited { text-decoration:none; color: black;}
  a:hover { text-decoration:none; font-weight:bold; background-color:#ff5; }
  a:active { text-decoration:none; font-weight:bold; background-color:#cff; }
  a:focus { text-decoration:none; font-weight:bold; background-color:#080; }
  div { position:absolute; } 
 
  #titel  { top: 10px; left: 10px; font-weight: bold; z-index:1; }
  #Tag { top: 10px; left: 150px}
  #Woche  { top: 10px; left: 200px}
  #Monat  { top: 10px; left: 280px}
  #Jahr  { top: 10px; left: 350px}
  #Temperaturen  { top: 10px; left: 420px}
  #rawdata { top: 10px; left: 600px}
 
  #id-2 { top: 65px; left:20px; border-width: 1px;  border-style:solid; border-color: black; padding:2px;}
  #id-1 { top: 65px; left:115px; border-width: 1px; border-style:solid; border-color: black; padding:2px;}
  
  #id1  { top:535px; left: 16px;  width:120px; text-align: center; font-weight: bold }
  
  #id4  { top: 450px; left:16px; width:120px; text-align: center; font-weight: bold } 
  #id5  { top: 150px; left:105px; font-weight: bold } 
  #id6  { top: 175px; left:105px; } 
  
  #id8  { top: 310px; left:105px; }
  #id9  { top: 570px; left:140px; width: 120px; text-align: center; color:  gray; font-size: 80%; }
  #id10 { top: 550px; left:140px; width: 120px; text-align: center; color: white; font-size: 80% }
  #id11 { top: 200px; left:105px; } 
  
  #id13 { top: 430px; left:168px; color: white; font-size: 80%; text-align:center; }
  
  #id15 { top: 340px; left:554px; width:100px; text-shadow: 0 1px 0 #000000, 0 -1px 0 #000000, 1px 0 0 #000000, -1px 0 0 #000000; color:#fff; font-weight: bold; text-align:center;} 
  #id16 { top: 500px; left:554px; width:100px; text-shadow: 0 1px 0 #000000, 0 -1px 0 #000000, 1px 0 0 #000000, -1px 0 0 #000000; color:#fff; font-weight: bold; text-align:center;} 
  
  #id17 { top: 340px; left: 700px; width:100px; text-shadow: 0 1px 0 #000000, 0 -1px 0 #000000, 1px 0 0 #000000, -1px 0 0 #000000; color:#fff; font-weight: bold; text-align:center;}
  #id18 { top: 600px; left:320px; }
  #id19 { top: 65px; left:190px;border-width: 1px;  border-style:solid; border-color: black; padding:2px;}
  #id20 { top: 170px; left:420px; } 
  #id21 { top: 150px; left:420px; font-weight: bold } 
  #id22 { top: 250px; left:420px;}
  #id23 { top: 270px; left:420px;}
  #id24 { top: 360px; left:16px; color: gray; width:120px; text-align: center; font-size: 60%; color: gray;}

  
  #id25 { top: 380px; left:16px; color: gray; width:120px; text-align: center; font-size: 60%; color: gray;}
  #id26 { top: 395px; left:16px; color: gray; width:120px; text-align: center; font-size: 60%; color: gray;}
  #id27 { top: 560px; left: 30px; font-size: small}
  #id28 { top: 350px; left: 65px; font-size: 60% ; color: white}
  
  #id29 { top: 475px; left:16px; color: gray; width:120px; text-align: center; } 
  
  #whitebox { background-color: white; }
 
</style>"
echo "</head>"
echo "<body style=\"background-image: url(../hydraulik_schema.png);  background-repeat:no-repeat;  background-position: centertop;\">"
printNavigation

# sehe zeilenweise in actual_data.txt nach und loesche Leerzeichen
for ZEILE in  `cat /var/www/actual_data.txt | sed s/" "/""/g`
do  
  # extrahiert die Messwertnummer 
  NR=`echo $ZEILE | cut -d ";" -f 1`  
  # extrahiert den Messwert und loescht ".0" am Ende
  WERT=`echo $ZEILE | cut -d ";" -f 3 | sed s/"\.0$"//g`
  EINHEIT="&deg;C" # setze Einheit standardmaessig auf °C
  INFO=""
    
  case $NR in 
      4|5|21) INFO="IST: " ;;
      29|20|6) INFO="SOLL: ";;
      8)  EINHEIT="%"
          INFO="Saugzug: ";;
      11) EINHEIT="%"
          INFO="O<sub>2</sub>: ";;
      10) EINHEIT="%"
          INFO="Einschub: ";;
      13) EINHEIT="%"
          INFO="F&uuml;llstand<br>";;
      -1|-2) EINHEIT="";;
      27) EINHEIT=" h" ;;
       9) EINHEIT="%"
          INFO="Zuluft: ";;
       1) EINHEIT=""
          case $WERT in
             1) WERT="abgeschaltet";;
             7) WERT="Vorbereiten";;
             2) WERT="Anheizen";;
             4) WERT="FEUERHALTUNG";;
             8) WERT="Vorw&auml;rm-<br>phase";;
             9) WERT="Z&uuml;nden";;
             3) WERT="Heizen";;
	    10) WERT="Abst.Warten";;
            11) WERT="Abst.Warten1";;
            13) WERT="Abst.Warten2";;
            14) WERT="Brenner aus";;
            15) WERT="Abreinigen";;
          esac ;;
      25) EINHEIT=""
          INFO="Starts: ";;
      26) EINHEIT=" h"
          INFO="Laufzeit: >";;
      #15|16|17|18) EINHEIT="&deg;C"
  esac
  
  # schreibe Container für aktuellen Messwert mit Info, Wert und Einheit
  echo "<div id=\"id$NR\">$INFO$WERT$EINHEIT</div>"
done

# schreibe einen Container, der die nicht verwendeten Messwerte uebderdeckt
echo "<div id=\"whitebox\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</div>"
echo "</body></html>" 
}

function printTable {
  echo "Content-type: text/html"
  echo ""
  echo "<html><head><title>Fr&ouml;ling P2 - $TITEL</title>"
  echo "<meta content=\"text/html; charset=UTF-8\" http-equiv=\"content-type\">"
  echo "<meta http-equiv=\"refresh\" content=\"60\">"
  echo "<style type=\"text/css\"> 
  body { margin: 10; font-family: sans-serif;} 
  div { position:absolute; } 
  a:link { text-decoration:none; color: black }
  a:visited { text-decoration:none; color: black;}
  a:hover { text-decoration:none; font-weight:bold; background-color:#ff5; }
  a:active { text-decoration:none; font-weight:bold; background-color:#cff; }
  a:focus { text-decoration:none; font-weight:bold; background-color:#080; }
  #titel { top: 10px; left: 10px; font-weight: bold}
  #status { top: 10px; left: 110px; }
  #tabelle  { top: 10px; left: 180px; font-weight: bold; color: gray}
  #rawdata { top: 10px; left:350px}
  </style>"
  echo "</head>"
  echo "<body>"
  
  printNavigation
  
  # Tabellenkopf
  echo "<table style=\"text-align: left; \" border=\"2\" cellpadding=\"0\"  cellspacing=\"0\">"
  echo "<tbody>"

  echo "<br><br>"
  
  for ZEILE in  `cat /var/www/actual_data.txt | sed s/" "/""/g`
  do
    echo "<tr>"
    
    case `echo $ZEILE | cut -d ";" -f 2` in
       Puffert.ob) FORMAT=" font-weight: bold;" ;;
       Puffert.un) FORMAT=" font-weight: bold;" ;;
                *) FORMAT=" " ;;
    esac 
  
    case `echo $ZEILE | cut -d ";" -f 2` in
       Anlagenzeit)  echo " ";;
                 *) ZEILE=`echo $ZEILE | sed s/"\.0$"//g` ;;
    esac
  
  
           NR=`echo $ZEILE | cut -d ";" -f 1`  
              echo "<td style=\"vertical-align: top; text-align: center;\">"
              echo "$NR"
              echo "</td>"
  
             
              NAME=`echo $ZEILE | cut -d ";" -f 2`  
              if ( echo $NAME | grep Au > /dev/null) then NAME="Au&szlig;entemp.";  fi
              echo "<td style=\"vertical-align: top;\">"
              echo "$NAME"
              echo "</td>"
  
              WERT=`echo $ZEILE | cut -d ";" -f 3`  
              echo "<td style=\"vertical-align: top; text-align:right; $FORMAT\">"
              echo "$WERT"
              echo "</td>"
    echo "</tr>"
  done

  #Tabellenende
  echo "</tbody>"
  echo "</table>"
  echo "</body></html>" 
}


case $QUERY_STRING in
       table) TITEL="Datentabelle"
             printTable;;
         **) TITEL="Status"
             printStatus;;
esac




#echo $TITEL
#echo $QUERY_STRING

# Inhalt von actual_data.txt
# -2  ;   Anlagendatum ; 15.11.2014
# -1  ;    Anlagenzeit ; 09:57:17
#  0;      Zustand 0 ;     6.0
#  1;      Zustand 1 ;     1.0
#  2;        Zustand ;     1.0
#  3;           ROST ;     0.0
#  4;     Kesseltemp ;    41.5
#  5;     Abgastemp. ;    38.0
#  6;     Abgas. SW  ;    48.0
#  7;    KessStellGr ;    61.0
#  8;      Saugzug   ;     0.0
#  9;     Zuluftgebl ;     0.0
# 10;       Einschub ;     0.0
# 11;        Rest-O2 ;     1.9
# 12;      O2-Regler ;   100.0
# 13;      Fuellst.: ;   100.0
# 14;     Feuerraumt ;   409.0
# 15;     Puffert.ob ;    67.5
# 16;     Puffert.un ;    27.5
# 17;     Puffer Pu. ;     0.0
# 18;        Koll T. ;    33.0
# 19;      Auáentemp ;     5.5
# 20;   Vorlauft.2sw ;     0.0
# 21;     Vorlauft.2 ;    32.0
# 22;      Fuehler 7 ;    28.0
# 23;        KTY6_H2 ;   254.0
# 24;        KTY7_H2 ;   254.0
# 25;       Brenn.ST ;  1381.0
# 26;      Laufzeit: ;  1760.0
# 27;     Koll Pumpe ; 12649.0
# 28;     Boardtemp. ;    29.0
# 29;Kesselsolltemp. ;    70.0
